package montre;

import java.awt.Point;
public class Aiguille {
    /* longueur de l'aiguille en nombre de pixels */
    private double longueur;
    /* nombre de cran dans le tour complet de la montre */
    private int max;
    /* centre de la montre sur laquelle l'aiguille est dessine */
    private int x, y;

    public Aiguille(int max, double longueur, int x, int y) {
        this.max = max;
        this.longueur = longueur;
        this.x = x;
        this.y = y;
    }
    
/** dessine l'aiguille avec une certaine position dans un espace 
 * graphique. On considre que 5% de la longueur de l'aiguille est 
 * dessine d'un ct du centre, 95% de l'autre ct
 * @param position de l'aiguille, 0position<12 
 */
    public void dessine(int position, java.awt.Graphics g) {
        // calcul de l'angle entre l'aiguille et la verticale
        double angle = (2*Math.PI*position)/max;

        // calcul de la position d'une extremite de l'aiguille
        Point bout = extremite(angle, longueur*0.95);
        
        // calcul de l'autre extremite de l'aiguille proche du centre
        Point centre = extremite(angle, -longueur*0.05);

        // dessine l'aiguille entre les deux points
        g.drawLine(centre.x, centre.y, bout.x, bout.y);
    }
    
    /** Cette mthode calcul la position d'un point dont les coordonnes
     * gomtrique par rapport au centre de la montre sont donnes par 
     * une distance est un angle. 
     * @param angle que forme l'aiguille par rapport  la verticale
     * @param distance par rapport au centre de la montre
     */
    private Point extremite(double angle, double distance) {
    // calcul l'abscisse
        double abscisse = x+distance*Math.sin(angle); 
        // calcul l'ordonne
        double ordonnee = y-distance*Math.cos(angle);
        return new Point((int)abscisse, (int)ordonnee);
    }
}
