package montre;

public class HorlogeAiguilles implements HorlogeVue {
    // La montre a 3 aiguilles
    private Aiguille heures, minutes, secondes;
    // Le rayon et les coordonnes du centre de l'horloge
    private int rayon, x, y;
    
    /** constructeur
     * @param rayon de la montre
     * @param x,y centre de la montre
     */
    public HorlogeAiguilles(int rayon, int x, int y) {
        // L'aiguille des heures a une longueur de 60% le rayon de la       // montre, les autres aiguilles ont une longueur de 100%
        heures = new Aiguille(12, rayon*0.6, x, y);
        minutes = new Aiguille(60, rayon*0.9, x, y);
        secondes = new Aiguille(60, rayon*0.9, x, y);

        this.rayon = rayon;
        this.x = x;
        this.y = y;
    }

    // impl?mente l'interface HorlogeVue
    public void dessine(Horloge horloge, java.awt.Graphics g) {
        // dessine le contour de la montre
        g.drawOval(x-rayon,y-rayon, 2*rayon, 2*rayon);

        // dessine les aiguilles de la montre
        heures.dessine(horloge.getHeures(), g);        
        minutes.dessine(horloge.getMinutes(), g);
        g.setColor(java.awt.Color.blue);
        secondes.dessine(horloge.getSecondes(), g); 
    }
    
    public java.awt.Dimension getPreferredSize() {
    	return new java.awt.Dimension(x+rayon, y+rayon);
    }    
}
